明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2565|回复: 3

怎样用VBA来修改属性块中的值

[复制链接]
发表于 2006-1-5 18:55:00 | 显示全部楼层 |阅读模式
本帖最后由 作者 于 2006-1-6 8:03:14 编辑

请教各位大侠,这个问题已经捆扰我好久了,就是怎样才能利用VBA(或者是VB也行)将我这属性中的数值相乘并写入当前这个属性块中呢??拜托各位了!

前提是必须要用VB语言来写的哦!

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2006-1-6 15:59:00 | 显示全部楼层

 BlkSet为选择集,应该能解决  

For Each elem In BlkSet
    'MsgBox elem
      With elem
        If StrComp(.EntityName, "AcDbBlockReference", 1) = 0 Then '如果块参照包含任何可编辑或固定(不可编辑)的属性时该属性为 TRUE 如果没有属性则为 FALSE。
           If .HasAttributes Then
                    Array1 = .GetAttributes '返回一个附着在块参照上可编辑的属性参照数组
                    'Array2 = .GetConstantAttributes '返回包含附着在块或外部参照的固定属性的数组
                    For Count = LBound(Array1) To UBound(Array1)
                            If StrComp(Array1(Count).EntityName, "AcDbAttribute", 1) = 0 Then
                           
                                    If Array1(Count).TagString = "序号" Then xuhao = Array1(Count).TextString
                            Array1(Count).TextString=xuhao*??

                            End If
                    Next Count
            End If
          End If
                 
      End With
    Next elem

 

 

 

 楼主| 发表于 2006-1-6 17:31:00 | 显示全部楼层
楼上这位大哥,我试了一下根本就不对啊!!
发表于 2006-1-9 23:10:00 | 显示全部楼层

参考一下.其中有块中属性的操作

Sub Example_GetAttributes()
    ' This example creates a block. It then adds attributes to that
    ' block. The block is then inserted into the drawing to create
    ' a block reference.
    
    ' Create the block
    Dim blockObj As AcadBlock
    Dim insertionPnt(0 To 2) As Double
    insertionPnt(0) = 0#: insertionPnt(1) = 0#: insertionPnt(2) = 0#
    Set blockObj = ThisDrawing.Blocks.Add(insertionPnt, "TESTBLOCK")
    
    ' Define the attribute definition
    Dim attributeObj As AcadAttribute
    Dim height As Double
    Dim mode As Long
    Dim prompt As String
    Dim insertionPoint(0 To 2) As Double
    Dim tag As String
    Dim value As String
    height = 1#
    mode = acAttributeModeVerify
    prompt = "Attribute Prompt"
    insertionPoint(0) = 5#: insertionPoint(1) = 5#: insertionPoint(2) = 0
    tag = "Attribute Tag"
    value = "Attribute Value"
    
    ' Create the attribute definition object in model space
    Set attributeObj = blockObj.AddAttribute(height, mode, prompt, insertionPoint, tag, value)
    
   
    ' Insert the block
    Dim blockRefObj As AcadBlockReference
    insertionPnt(0) = 2#: insertionPnt(1) = 2#: insertionPnt(2) = 0
    Set blockRefObj = ThisDrawing.ModelSpace.InsertBlock(insertionPnt, "TESTBLOCK", 1#, 1#, 1#, 0)
    ZoomAll
    
    ' Get the attributes for the block reference
    Dim varAttributes As Variant
    varAttributes = blockRefObj.GetAttributes
    
    ' Move the attribute tags and values into a string to be displayed in a Msgbox
    Dim strAttributes As String
    Dim I As Integer
    For I = LBound(varAttributes) To UBound(varAttributes)
        strAttributes = strAttributes & "  Tag: " & varAttributes(I).TagString & _
                        "   Value: " & varAttributes(I).textString & "    "
    Next
    MsgBox "The attributes for blockReference " & blockRefObj.name & " are: " & strAttributes, , "GetAttributes Example"
    
    ' Change the value of the attribute
    ' Note: There is no SetAttributes. Once you have the variant array, you have the objects.
    ' Changing them changes the objects in the drawing.
    varAttributes(0).textString = "NEW VALUE!"
    
    ' Get the attributes
    Dim newvarAttributes As Variant
    newvarAttributes = blockRefObj.GetAttributes
    
    ' Again, display the tags and values
    strAttributes = ""
    For I = LBound(varAttributes) To UBound(varAttributes)
        strAttributes = strAttributes & "  Tag: " & varAttributes(I).TagString & _
                        "   Value: " & varAttributes(I).textString & "    "
    Next
    MsgBox "The attributes for blockReference " & blockRefObj.name & " are: " & strAttributes, , "GetAttributes Example"
    
End Sub
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-27 06:32 , Processed in 0.181478 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表